CON                         
  _clkmode    = xtal1 + pll16x                             ' Set chip to run at 16 times the installed crystal
  _xinfreq    = 5_000_000                                  ' Define the installed crystal


  VexRcvPin   = 6      

  VideoPins   = 12                                         ' PINs where Video interface is installed
  VideoCls    = 0                                          ' Video driver clear screen code

  CR          = 13                                         ' ASCII <CR>
  LF          = 10                                         ' ASCII <LF>                   

VAR           
  long channelValues[6]
  long decodeValid            

  
OBJ           
    VEX : "VEXDemux"                                       ' Create VEX Demux Object
    term: "tv_text"                                        ' Declare Video Display object 


PUB Start 

  term.Start(VideoPins)                                    ' Instantiates Video Display
  term.Out(VideoCls)                                       ' Clear Video Display

  VEX.Start (VexRcvPin, @channelValues, @decodeValid)      ' Initialize VEX Decoder Object
                                                           ' VexRcvPin - VEX Receiver PPM Output        
                                                           ' channelValues - current channel, values in microseconds
                                                           ' decodeValid - flag indicating that a VEX PPM pulse train
                                                           '               is currently being de-multiplexed
  Main

  
Pub Main

  repeat 
    SetXY(0,0)
    term.str(string("Vex R/C Reciever De-Multiplexer", CR))
    if decodeValid == true
      term.str(string(CR, "Channel 1: "))
      term.dec(channelValues[0])
      term.str(string(CR, "Channel 2: "))
      term.dec(channelValues[1])
      term.str(string(CR, "Channel 3: "))
      term.dec(channelValues[2])
      term.str(string(CR, "Channel 4: "))
      term.dec(channelValues[3])
      term.str(string(CR, "Channel 5: "))
      term.dec(channelValues[4])
      term.str(string(CR, "Channel 6: "))
      term.dec(channelValues[5])

  
PUB SetXY(x, y)

  ' This needs to be moved to the TV_Text wrapper, placed here for compatability for existing object

  term.out($A)                                             ' set X position (X follows)
  term.out(x)
   
  term.out($B)                                             ' set Y position (Y follows)
  term.out(y)

                                                          